Graphics3D 640,480,16,2
SetBuffer BackBuffer()
AmbientLight 255,255,255

;load model
Global model=LoadMesh("teapot.3ds")
EntityFX model,3

model2=LoadMesh("teapot.3ds")
EntityFX model2,2
FlipMesh model2
EntityColor model2,0,0,0

Global xm#,zm#

camera=CreateCamera()
light=CreateLight()
PositionEntity camera,-100,70,-10
CameraClsColor camera,0,255,0
PointEntity camera,model

;scale model
For count=1 To CountSurfaces(model2)
	surf=GetSurface(model2,count)
	For a=0 To CountVertices(surf)-1
		xm#=VertexNX(surf,a)*1.5
		ym#=VertexNY(surf,a)*1.5
		zm#=VertexNZ(surf,a)*1.5
		x#=VertexX(surf,a)
		y#=VertexY(surf,a)
		z#=VertexZ(surf,a)
		VertexCoords surf,a,x-xm,y-ym,z-zm
		VertexColor surf,a,0,0,0
	Next
Next

shading(model)
;HideEntity model2

;render
While Not KeyHit(1)
	Cls
	;RotateMesh model,0,1,0
	TurnEntity model,0,1,0
	TurnEntity model2,0,1,0
	;RotateMesh model2,0,1,0
	;shading(model)
	RenderWorld
	UpdateWorld
	
	c=c+1
	If MilliSecs()>(timer+1000)
		timer=MilliSecs()
		fps=c
		c=0
	EndIf
	
	Color 0,0,0
	Text 0,0,"fps ="+fps
	Text 0,20,"Polygon= "+2256
	Flip
Wend
End

Function shading(model)
For count=1 To CountSurfaces(model)
	surf=GetSurface(model,count)
	For a=0 To CountTriangles(surf)-1
		xm1#=VertexNX(surf,TriangleVertex(surf,a,0))
		ym1#=VertexNY(surf,TriangleVertex(surf,a,0))
		zm1#=VertexNZ(surf,TriangleVertex(surf,a,0))

		xm2#=VertexNX(surf,TriangleVertex(surf,a,2))
		ym2#=VertexNY(surf,TriangleVertex(surf,a,2))
		zm2#=VertexNZ(surf,TriangleVertex(surf,a,2))

		xm3#=VertexNX(surf,TriangleVertex(surf,a,1))
		ym3#=VertexNY(surf,TriangleVertex(surf,a,1))
		zm3#=VertexNZ(surf,TriangleVertex(surf,a,1))
				
		
		If (zm1>=-1) And (zm2>=-1) And (zm3>=-1)
			VertexColor surf,TriangleVertex(surf,a,0),64,64,64
			VertexColor surf,TriangleVertex(surf,a,1),64,64,64
			VertexColor surf,TriangleVertex(surf,a,2),64,64,64
		EndIf
		
		If (zm1>-.5) And (zm2>-.5) And (zm3>-.5)
			VertexColor surf,TriangleVertex(surf,a,0),128,128,128
			VertexColor surf,TriangleVertex(surf,a,1),128,128,128
			VertexColor surf,TriangleVertex(surf,a,2),128,128,128
		EndIf
		
		If (zm1>0) And (zm2>0) And (zm3>0)
			VertexColor surf,TriangleVertex(surf,a,0),192,192,192
			VertexColor surf,TriangleVertex(surf,a,1),192,192,192
			VertexColor surf,TriangleVertex(surf,a,2),192,192,192
		EndIf
		
		If (zm1>.5) And (zm2>.5) And (zm3>.5)
			VertexColor surf,TriangleVertex(surf,a,0),255,255,255
			VertexColor surf,TriangleVertex(surf,a,1),255,255,255
			VertexColor surf,TriangleVertex(surf,a,2),255,255,255
		EndIf
	Next
Next
End Function